var modul2 = {
    thermometer: {
        initialize() {
            var container = sm.element('thermometer-container');
            var thermometer = sm.element('thermometer')

            if (typeof container._thermometer == "undefined") {
                container._thermometer = thermometer;
                thermometer._dragging = false;
                thermometer._container = container;
    
                thermometer.addEventListener('mousedown', modul2.thermometer.drag);
                container.addEventListener('mouseup', modul2.thermometer.undrag);
                container.addEventListener('mousemove', modul2.thermometer.mousemove);

                container._buckets = eval(container.getAttribute('sm-buckets'));
                console.log(container._buckets);

                modul2.thermometer.set(19);
            }
        },

        set(temperature) {
            var fluid = sm.element('thermometer-fluid');
            fluid.style.height = (temperature / 100 * 44 + 15) + '%';

            var line = sm.element('thermometer-line');
            if (line != undefined) {
                line.style.bottom = (temperature / 100 * 35.4 + 30.6) + '%';
            }
            line = sm.element('thermometer-vline');
            if (line != undefined) {
                line.style.left = (temperature / 100 * 176 + 83) + 'px';
            }
        },

        drag(event) {
            var thermometer = this;
            var container = thermometer._container;

            var rect = thermometer.getBoundingClientRect();
            thermometer._dragX = event.clientX - rect.left + thermometer.offsetLeft;
            thermometer._dragY = event.clientY - rect.top + thermometer.offsetTop;
            thermometer._startX = thermometer.offsetLeft + rect.width/2;
            thermometer._startY = thermometer.offsetTop;

            thermometer._dragging = true;
            container.classList.add('dragging');
        },

        locate(x, y) {
            var container = sm.element('thermometer-container');
            var thermometer = sm.element('thermometer');

            var rect = container.getBoundingClientRect();
            thermometer.style.left = (x / rect.width * 100).toFixed(2) + '%';
            thermometer.style.top = (y / rect.height * 100).toFixed(2) + '%';
        },

        mousemove(event) {
            var container = this;
            var thermometer = container._thermometer;

            /* Wird der Thermometer gerade verschoben? */
            if (thermometer._dragging) {
                var rect = container.getBoundingClientRect();
                var dx = event.clientX - rect.left - thermometer._dragX;
                var dy = event.clientY - rect.top - thermometer._dragY;
                var x = thermometer._startX + dx;
                var y = thermometer._startY + dy;

                thermometer._x = x;
                thermometer._y = y;

                var fang = false;

                if (y > 10) {
                    for (i = 0; i < container._buckets.length; i++) {
                        var bucket = container._buckets[i];
                        var pos = bucket.pos * (rect.width - 100) + 50;
                        if (x > pos - 50 && x < pos + 50) {
                            modul2.thermometer.set(bucket.theta);
                            thermometer._fangX = pos;
                            thermometer._fangY = 45;
                            fang = true;
                            container.classList.add('fang');
                            break;
                        }
                    }
                } else {
                    fang = false;
                }

                if (fang == false) {
                    container.classList.remove('fang');
                    modul2.thermometer.set(19);
                    thermometer._fangX = x;
                    thermometer._fangY = y;
                }

                modul2.thermometer.locate(x, y);
            }
        },

        undrag(event) {
            var container = this;

            modul2.thermometer.locate(container._thermometer._fangX, container._thermometer._fangY);

            container._thermometer._dragging = false;
            container.classList.remove('dragging');
        }
    }
}